-- The following statements assume incremental ACME database creation
-- started in Chapter 2 after creating an empty database using empty_acme.sql script.

CREATE TABLE salesman
(
salesman_id_n INT CONSTRAINT pk_salesmanprim PRIMARY KEY NOT NULL,
salesman_code_s VARCHAR (2) CONSTRAINT uk_salescode UNIQUE NOT NULL,
salesman_name_s     VARCHAR (50) NOT NULL,
salesman_status_s   CHAR (1)     CONSTRAINT chk_salesstatus CHECK
                                   (salesman_status_s in ('N', 'Y')))
; 


CREATE TABLE address
(
    addr_id_n          INT         CONSTRAINT pk_addrprimary PRIMARY KEY NOT NULL,
    addr_custid_fn     INT,
    addr_salesmanid_fn INT         CONSTRAINT fk_addr_salesman
                                     REFERENCES salesman (salesman_id_n),
    addr_address_s     VARCHAR(60),
    addr_type_s        VARCHAR(8)  CONSTRAINT chk_addr_type CHECK
                                      (addr_type_s IN ('BILLING', 'SHIPPING')),
    addr_city_s        VARCHAR(18) CONSTRAINT nn_addr_city   NOT NULL,
    addr_state_s       CHAR(2),
    addr_zip_s         VARCHAR(10) NOT NULL,
    addr_country_s     CHAR(3)
 );


CREATE TABLE product
(
prod_id_n INTEGER NOT NULL,
prod_price_n DECIMAL(10,2),
prod_num_s VARCHAR(10),
prod_description_s VARCHAR(44) NOT NULL,
prod_status_s CHAR(1) DEFAULT 'Y',
prod_brand_s VARCHAR(20) NOT NULL,
prod_pltwid_n DECIMAL(5,2) NOT NULL,
prod_pltlen_n DECIMAL(5,2) NOT NULL,
prod_netwght_n DECIMAL(10,3),
prod_shipweight_n DECIMAL(10,3)   
);

INSERT INTO product
( prod_id_n,
prod_price_n,
prod_num_s,
prod_description_s,
prod_brand_s,
prod_pltwid_n,
prod_pltlen_n,
prod_netwght_n,
prod_shipweight_n
)
VALUES
(990,18.24,'990','SPRUCE LUMBER 30X40X50',
'SPRUCE LUMBER',4,6,21.22577,24.22577);   

SELECT prod_id_n,
prod_price_n,
prod_status_s
FROM product;           

CREATE TABLE order_header
(
ordhdr_id_n INTEGER NOT NULL,
ordhdr_payterms_fn INTEGER,
ordhdr_statusid_fn INTEGER,
ordhdr_custid_fn INTEGER,
ordhdr_salesmanid_fn INTEGER,
ordhdr_nbr_s VARCHAR(30) NOT NULL,
ordhdr_invoicenbr_n INTEGER,
ordhdr_orderdate_d DATE,
ordhdr_invoicedate_d DATE,
ordhdr_canceldate_d DATE,
ordhdr_credithold_s CHAR(1),
ordhdr_readytoinvoice_s CHAR(1) DEFAULT 'N',
ordhdr_notes_s VARCHAR(60),
ordhdr_createdby_s VARCHAR(10),
ordhdr_createdate_d DATE,
CONSTRAINT chk_ordhdr_ready CHECK
(ordhdr_readytoinvoice_s IN ('N', 'Y')),
CONSTRAINT chk_ordhdr_credh CHECK
(ordhdr_credithold_s IN ('N', 'Y')),
CONSTRAINT pk_ordhdrprim PRIMARY KEY (ordhdr_id_n),
CONSTRAINT idx_ordhdr_ordnbr UNIQUE (ordhdr_nbr_s)
);  


CREATE TABLE shipment
(
shipment_id_n INTEGER NOT NULL,
shipment_bolnum_s VARCHAR(6),
shipment_shipdate_d DATE,
shipment_arrivdate_d DATE,
shipment_totalcases_n INTEGER,
shipment_trailernbr_s VARCHAR(12),
shipment_shpmntfrght_n DECIMAL(12,2),
shipment_frtterms_s VARCHAR(3),
shipment_createdby_s VARCHAR(10),
shipment_createdate_d DATE,
CONSTRAINT chk_shipfrtterms CHECK
(shipment_frtterms_s IN ('COL', 'PPD')),
CONSTRAINT pk_shipmentrprim PRIMARY KEY (shipment_id_n)
);  


CREATE TABLE order_shipment
(
ordship_ordhdr_id_fn INTEGER NOT NULL,
ordship_shipment_id_fn INTEGER NOT NULL,
CONSTRAINT pk_ordhdrship PRIMARY KEY
(ordship_ordhdr_id_fn, ordship_shipment_id_fn),
CONSTRAINT fk_ordsh_ord FOREIGN KEY (ordship_ordhdr_id_fn)
REFERENCES order_header(ordhdr_id_n)
);        

INSERT INTO salesman
(
salesman_id_n,
salesman_code_s,
salesman_name_s,
salesman_status_s
)
VALUES
(23,'02','FAIRFIELD BUGS ASSOCIATION','Y');  



INSERT INTO address
(
addr_id_n,
addr_custid_fn,
addr_salesmanid_fn,
addr_address_s,
addr_type_s,
addr_city_s,
addr_state_s,
addr_zip_s,
addr_country_s
)
VALUES
(49,NULL,23,'223 E FLAGLER ST.',NULL,'MIAMI','FL','33131','USA'); 


DELETE FROM salesman;  


DROP TABLE address;

DROP TABLE salesman; 

CREATE TABLE salesman
(
salesman_id_n INT CONSTRAINT pk_salesmanprim PRIMARY KEY NOT NULL,
salesman_code_s VARCHAR (2) CONSTRAINT uk_salescode UNIQUE NOT NULL,
salesman_name_s VARCHAR (50) NOT NULL,
salesman_status_s CHAR (1) CONSTRAINT chk_salesstatus CHECK (salesman_status_s in ('N', 'Y'))
);  

CREATE TABLE address
(
addr_id_n INT CONSTRAINT pk_addrprimary PRIMARY KEY NOT NULL,
addr_custid_fn INT,
addr_salesmanid_fn INT CONSTRAINT fk_addr_salesman
REFERENCES salesman (salesman_id_n)
ON DELETE CASCADE,
addr_address_s VARCHAR(60),
addr_type_s VARCHAR(8) CONSTRAINT chk_addr_type CHECK
(addr_type_s IN ('BILLING', 'SHIPPING')),
addr_city_s VARCHAR(18) CONSTRAINT nn_addr_city NOT NULL,
addr_state_s CHAR(2),
addr_zip_s VARCHAR(10) NOT NULL,
addr_country_s CHAR(3)
);

INSERT INTO salesman
(
salesman_id_n,
salesman_code_s,
salesman_name_s,
salesman_status_s
)
VALUES
(23,'02','FAIRFIELD BUGS ASSOCIATION','Y');


INSERT INTO address
(
addr_id_n,
addr_custid_fn,
addr_salesmanid_fn,
addr_address_s,
addr_type_s,
addr_city_s,
addr_state_s,
addr_zip_s,
addr_country_s
)
VALUES
(49,NULL,23,'223 E FLAGLER ST.',NULL,'MIAMI','FL','33131','USA');

SELECT * FROM ADDRESS;

DELETE FROM salesman;

SELECT * FROM address; 



CREATE TABLE phone
(
phone_id_n           INTEGER          NOT NULL,
phone_custid_fn      INTEGER,
phone_salesmanid_fn  INTEGER,
phone_phonenum_s     VARCHAR(20),
phone_type_s         VARCHAR(20),
CONSTRAINT chk_phone_type CHECK
(phone_type_s IN ('PHONE', 'FAX')),
CONSTRAINT pk_phonerimary PRIMARY KEY (phone_id_n)
);

CREATE TABLE payment_terms
(
    payterms_id_n           INTEGER 
                             GENERATED ALWAYS AS IDENTITY 
                             (START WITH 1
                              INCREMENT BY 1
                              MINVALUE 1
                              MAXVALUE 10000
                              NO CYCLE),
    payterms_code_s         VARCHAR(6),
    payterms_desc_s         VARCHAR(60),
    payterms_discpct_n      DECIMAL(5,2),
    payterms_daystopay_n    INTEGER,
    CONSTRAINT pk_payterms PRIMARY KEY (payterms_id_n)
);

CREATE TABLE payment_terms2
AS (SELECT * FROM payment_terms)
DEFINITION ONLY;

CREATE TABLE payment_terms3
LIKE payment_terms;

CREATE TABLE order_line
(
    ordline_id_n            INT          NOT NULL,
    ordline_ordhdrid_fn     INT          NOT NULL,
    ordline_prodid_fn       INT,
    ordline_ordqty_n        INT,
    ordline_shipqty_n       INT,
    ordline_createdate_d    DATE,
    ordline_createdby_s     VARCHAR(10),
    CONSTRAINT pk_ordlineprim PRIMARY KEY (ordline_id_n)
);

CREATE TABLE   orderline_summary
AS
(
 SELECT        ordline_ordhdrid_fn,
               SUM(ordline_ordqty_n) AS ord_qty_summary,
               SUM(ordline_shipqty_n) AS ship_qty_summary,
               COUNT (*) AS rowcount
 FROM          order_line
 GROUP BY      ordline_ordhdrid_fn
)
DATA INITIALLY DEFERRED REFRESH DEFERRED;

SELECT *
FROM phone
WHERE phone_custid_fn = 152;

CREATE TABLE CUSTOMER(
    CUST_ID_N             INTEGER          NOT NULL,
    CUST_PAYTERMSID_FN    INTEGER,
    CUST_SALESMANID_FN    INTEGER,
    CUST_STATUS_S         VARCHAR(1)     DEFAULT 'Y' NOT NULL,
    CUST_NAME_S           VARCHAR(50)    NOT NULL,
    CUST_ALIAS_S          VARCHAR(15),
    CUST_CREDHOLD_S       VARCHAR(1)     DEFAULT 'Y' NOT NULL,
    CONSTRAINT CHK_CUST_STATUS CHECK (CUST_STATUS_S IN ('N', 'Y')),
    CONSTRAINT CHK_CUST_CREDHOLD CHECK (CUST_CREDHOLD_S IN ('N', 'Y')),
    CONSTRAINT PK_CUSTPRIMARY PRIMARY KEY (CUST_ID_N)
) 
;

CREATE UNIQUE INDEX idx_cust_name_als
ON customer(cust_name_s, cust_alias_s);

CREATE UNIQUE INDEX idx_cust_name_als_plus
ON customer(cust_name_s, cust_alias_s)
INCLUDE (cust_credhold_s, cust_status_s);

CREATE VIEW v_exchange_rate
(
 currency_name,
 exchange_rate,
converted_price
)
AS VALUES
('Canadian Dollars', CAST (0.9552514569 AS DECIMAL(20,10)), 0), 
('Euro', CAST (1.3802345617 AS DECIMAL(20,10)), 0), 
('Japanese Yen', CAST (0.0082457044 AS DECIMAL(20,10)), 0) ;

SELECT * FROM v_exchange_rate;

CREATE VIEW v_customer_totals
(
   customer_name,
   order_number,
   total_price
)
AS
(
 SELECT   customer.cust_name_s,
          order_header.ordhdr_nbr_s,
          sum(product.prod_price_n * order_line.ordline_ordqty_n)
 FROM     customer,
          order_header,
          order_line,
          product
 WHERE    customer.cust_id_n = order_header.ordhdr_custid_fn
 AND      order_header.ordhdr_id_n = order_line.ordline_ordhdrid_fn
 AND      product.prod_id_n = order_line.ordline_prodid_fn
 AND      order_line.ordline_ordqty_n IS NOT NULL
 GROUP BY customer.cust_name_s,
          order_header.ordhdr_nbr_s
);

CREATE VIEW   v_customer_totals_over_15000
AS
SELECT        *
FROM          v_customer_totals
WHERE         total_price > 15000;

CREATE VIEW v_contact_list
(
 name,
 phone_number,
 contact_type
)
AS
SELECT   cust_name_s,
         phone_phonenum_s,
         'customer'
FROM     customer,
         phone
WHERE    cust_id_n = phone_custid_fn
AND      phone_type_s = 'PHONE'
UNION
SELECT   salesman_name_s,
         phone_phonenum_s,
         'salesperson'
FROM     salesman,
         phone
WHERE    salesman_id_n = phone_salesmanid_fn
AND      phone_type_s = 'PHONE';

CREATE VIEW v_wile_bess_orders
(
 order_number,
 order_date
)
AS
SELECT   ordhdr_nbr_s,
         ordhdr_orderdate_d
FROM     order_header
WHERE    ordhdr_custid_fn IN
   (
    SELECT  cust_id_n
    FROM    customer
    WHERE   cust_name_s = 'WILE BESS COMPANY'
   );

CREATE SEQUENCE my_sequence4
START WITH 100
INCREMENT BY 1
MINVALUE 10
MAXVALUE 10000
CYCLE;

SELECT NEXTVAL FOR my_sequence4 AS NEXTVAL
FROM SYSIBM.SYSDUMMY1;

SELECT PREVVAL FOR my_sequence4 AS PREVVAL
FROM SYSIBM.SYSDUMMY1;

SELECT PREVVAL FOR my_sequence4 AS PREVVAL
FROM SYSIBM.SYSDUMMY1;

CREATE TABLESPACE USERDATA03
MANAGED BY SYSTEM
USING ('C:\DB2\DATA01');