-- The following statements assume incremental ACME database creation
-- started in Chapter 2  and Chapter 4 after creating 
-- an empty database using empty_acme.sql script.

ALTER TABLE PHONE
ADD PHONE_PRIMARY_S CHAR(1) DEFAULT 'Y'
CHECK (PHONE_PRIMARY_S IN ('Y',
'N'))
ADD PHONE_CATEGORY_S CHAR(15);

ALTER TABLE CUSTOMER
ALTER COLUMN CUST_ALIAS_S SET DATA TYPE VARCHAR (20);

ALTER TABLE CUSTOMER
ALTER COLUMN CUST_ALIAS_S SET DATA TYPE CHARACTER (30);

ALTER TABLE CUSTOMER
ALTER COLUMN CUST_ALIAS_S SET DATA TYPE VARCHAR (10);

ALTER TABLE PHONE
ALTER COLUMN PHONE_PRIMARY_S SET NOT NULL
ALTER COLUMN PHONE_CATEGORY_S SET DEFAULT 'BUSINESS';

ALTER TABLE payment_terms
ALTER COLUMN payterms_id_n
SET CYCLE
SET MAXVALUE 500
RESTART WITH 100;

ALTER TABLE product
ADD CONSTRAINT pk_productprim PRIMARY KEY (prod_id_n);

ALTER TABLE customer ADD CONSTRAINT fk_cust_payterms
FOREIGN KEY (cust_paytermsid_fn)
REFERENCES payment_terms (payterms_id_n);

ALTER TABLE customer ADD CONSTRAINT fk_cust_salesman
FOREIGN KEY (cust_salesmanid_fn)
REFERENCES salesman (salesman_id_n);

ALTER TABLE order_line ADD CONSTRAINT fk_ordline_ordhdr
FOREIGN KEY (ordline_ordhdrid_fn)
REFERENCES order_header (ordhdr_id_n);

ALTER TABLE order_line ADD CONSTRAINT
fk_ordline_product
FOREIGN KEY (ordline_prodid_fn)
REFERENCES product (prod_id_n);

ALTER TABLE SALESMAN
DROP CONSTRAINT uk_salescode;

ALTER TABLE orderline_summary
SET SUMMARY AS DEFINITION ONLY;

DROP INDEX idx_phone_cust;

ALTER SEQUENCE my_sequence4
RESTART WITH 1
INCREMENT BY 1
NOMAXVALUE
NOCYCLE;

DROP SEQUENCE my_sequence2 RESTRICT;








 