-- The following statements assume incremental ACME database creation
-- started in Chapter 2, Chapter 4, and Chapter 5 after creating 
-- an empty database using empty_acme.sql script.

INSERT INTO product
(
prod_id_n,
prod_num_s,
prod_description_s,
prod_status_s,
prod_brand_s,
prod_pltwid_n,
prod_pltlen_n
)
VALUES
(
991,
'991',
'SPRUCE LUMBER 30X40X50',
'N',
'SPRUCE LUMBER',
4,
6
);

INSERT INTO payment_terms3
(
payterms_id_n,
payterms_code_s,
payterms_desc_s,
payterms_discpct_n,
payterms_daystopay_n
)
VALUES
(
27,
'N21531',
'2% 15 NET 30',
0.02,
31
);

INSERT INTO payment_terms3
(
payterms_id_n,
payterms_code_s,
payterms_desc_s,
payterms_discpct_n,
payterms_daystopay_n
)
VALUES
(
28,
'N21530',
'2% 15 NET 30',
0.02,
30
);

INSERT INTO salesman
(
salesman_id_n,
salesman_code_s,
salesman_name_s
)
VALUES
(
22,
'0B',
'FAIRFIELD MOSQUITO ASSOCIATION'
);

SELECT *
FROM salesman
WHERE salesman_code_s = '0B';

CREATE TABLE CUSTOMER(
    CUST_ID_N             INTEGER          NOT NULL,
    CUST_PAYTERMSID_FN    INTEGER,
    CUST_SALESMANID_FN    INTEGER,
    CUST_STATUS_S         VARCHAR(1)     DEFAULT 'Y' NOT NULL,
    CUST_NAME_S           VARCHAR(50)    NOT NULL,
    CUST_ALIAS_S          VARCHAR(15),
    CUST_CREDHOLD_S       VARCHAR(1)     DEFAULT 'Y' NOT NULL,
    CONSTRAINT CHK_CUST_STATUS CHECK (CUST_STATUS_S IN ('N', 'Y')),
    CONSTRAINT CHK_CUST_CREDHOLD CHECK (CUST_CREDHOLD_S IN ('N', 'Y')),
    CONSTRAINT PK_CUSTPRIMARY PRIMARY KEY (CUST_ID_N)
) 
;


INSERT INTO customer
(
cust_id_n,
cust_paytermsid_fn,
cust_salesmanid_fn,
cust_name_s,
cust_alias_s,
cust_credhold_s
)
VALUES
(
1,
27,
24,
'WILE SEAL CORP.',
'MNGA71396',
'Y'
);

SELECT cust_status_s
FROM customer
WHERE cust_alias_s = 'MNGA71396';

INSERT INTO product
(
prod_id_n,
prod_price_n,
prod_num_s,
prod_description_s,
prod_status_s,
prod_brand_s,
prod_pltwid_n,
prod_pltlen_n,
prod_netwght_n,
prod_shipweight_n
)
VALUES
(
1880,
33.28,
'1880',
'STEEL NAILS 6''''',
'Y',
'STEEL NAILS',
5,
4,
38.39148,
42.39148
);



INSERT INTO product
(
prod_id_n,
prod_price_n,
prod_num_s,
prod_description_s,
prod_status_s,
prod_brand_s,
prod_pltwid_n,
prod_pltlen_n,
prod_netwght_n,
prod_shipweight_n
)
VALUES
(
5786,
NULL,
'5786',
'CRATING MATERIAL 12X48X72',
'Y',
'CRATING MATERIAL',
5,
6,
20.37674,
23.37674
);

INSERT INTO order_header
VALUES
(
30670,
28,
NULL,
1,
24,
'523783',
NULL,
NULL,
NULL,
NULL,
'N',
'Y',
NULL,
'RR',
NULL
);

INSERT INTO salesman
VALUES
(
24,
'03',
'AMERICA GONZALES LIMITED',
DEFAULT
);

INSERT INTO salesman
(
salesman_id_n,
salesman_code_s,
salesman_name_s,
salesman_status_s
)
VALUES
(
26,
'07',
'ELMERSON INDUSTRIES INCORPORATED','A'
);


INSERT INTO status
(
status_id_n,
status_code_s,
status_desc_s
)
VALUES
( 2, '20', 'COMPLETE'),
( 6, '60', 'SHIPPED'),
( 8, '70', 'INVOICED'),
( 9, '80', 'CANCELLED');

SELECT * FROM status;

CREATE SEQUENCE seq_addr;

INSERT INTO address
(
addr_id_n,
addr_custid_fn,
addr_salesmanid_fn,
addr_address_s,
addr_type_s,
addr_city_s,
addr_state_s,
addr_zip_s,
addr_country_s
)
VALUES
(
NEXTVAL FOR SEQ_ADDR,
NULL,
23,
'223 E FLAGLER ST.',
NULL,
'MIAMI',
'FL',
'33131',
'USA'
);

UPDATE product
SET prod_price_n = 34.76;

UPDATE product
SET prod_price_n = 34.76
WHERE prod_num_s = '1880';

UPDATE product
SET prod_price_n = 18.24
WHERE prod_id_n = 990;

UPDATE product
SET prod_pltwid_n = 5,
prod_pltlen_n = 7
WHERE prod_id_n = 990;

UPDATE product
SET prod_price_n = prod_price_n * 1.1;

UPDATE order_header
SET ordhdr_payterms_fn =
(SELECT payterms_id_n
FROM payment_terms
WHERE payterms_code_s = 'N21531')
WHERE ordhdr_id_n = 30670;

UPDATE order_header
SET ordhdr_payterms_fn =
(SELECT payterms_id_n
FROM payment_terms,
customer
WHERE payterms_id_n = cust_paytermsid_fn
AND ordhdr_custid_fn = cust_id_n);

CREATE TABLE small_product AS
(SELECT * FROM PRODUCT)
DEFINITION ONLY;

INSERT INTO small_product
(SELECT * FROM product
WHERE prod_shipweight_n < 30);

UPDATE small_product
SET (prod_pltwid_n, prod_pltlen_n) = (SELECT
prod_pltwid_n, prod_pltlen_n
FROM product
WHERE prod_id_n =
5786)
WHERE prod_id_n = 5786;

UPDATE small_product
SET (prod_pltwid_n, prod_pltlen_n) = (55, 99)
WHERE prod_id_n = 5786;

DELETE FROM salesman
WHERE salesman_code_s = '02';


DELETE FROM phone;

DELETE FROM order_header
WHERE ordhdr_custid_fn =
(SELECT cust_id_n
FROM customer
WHERE cust_name_s = 'WILE SEAL
CORP.');

CREATE TABLE LOCAL_PRODUCT
(
PROD_ID_N INTEGER NOT NULL,
PROD_PRICE_N INTEGER,
PROD_NUM_S VARCHAR (10),
PROD_DESCRIPTION_S VARCHAR (44) NOT NULL,
PROD_STATUS_S CHAR (1) DEFAULT 'Y',
PROD_BRAND_S VARCHAR (20) NOT NULL,
PROD_PLTWID_N INTEGER NOT NULL,
PROD_PLTLEN_N INTEGER NOT NULL,
PROD_NETWGHT_N INTEGER,
PROD_SHIPWEIGHT_N INTEGER,
CONSTRAINT CHK_LPRODSTATUS
CHECK (PROD_STATUS_S in ('N', 'Y')),
CONSTRAINT PK_LPRODUCTPRIM PRIMARY KEY ( PROD_ID_N )
);

MERGE INTO local_product lp
USING product p ON (lp.prod_id_n = p.prod_id_n )
WHEN MATCHED THEN UPDATE
SET lp.prod_price_n = p.prod_price_n,
lp.prod_status_s = p.prod_status_s,
lp.prod_pltwid_n = p.prod_pltwid_n,
lp.prod_pltlen_n = p.prod_pltlen_n,
lp.prod_shipweight_n = p.prod_shipweight_n
WHEN NOT MATCHED THEN INSERT
VALUES (p.prod_id_n,
p.prod_price_n,
p.prod_num_s,
p.prod_description_s,
p.prod_status_s,
p.prod_brand_s,
p.prod_pltwid_n,
p.prod_pltlen_n,
p.prod_netwght_n,
p.prod_shipweight_n);

MERGE INTO local_product lp
USING product p ON (lp.prod_id_n = p.prod_id_n )
WHEN MATCHED AND (p.prod_status_s = 'Y') THEN UPDATE
SET lp.prod_price_n = p.prod_price_n,
lp.prod_status_s = p.prod_status_s,
lp.prod_pltwid_n = p.prod_pltwid_n,
lp.prod_pltlen_n = p.prod_pltlen_n,
lp.prod_shipweight_n = p.prod_shipweight_n
WHEN MATCHED AND (p.prod_status_s = 'N') THEN DELETE
WHEN NOT MATCHED THEN INSERT
VALUES (p.prod_id_n,
p.prod_price_n,
p.prod_num_s,
p.prod_description_s,
p.prod_status_s,
p.prod_brand_s,
p.prod_pltwid_n,
p.prod_pltlen_n,
p.prod_netwght_n,
p.prod_shipweight_n);




