
SELECT cust_id_n,
cust_name_s,
phone_phonenum_s,
phone_type_s
FROM customer JOIN phone
ON cust_id_n = phone_custid_fn;

SELECT customer.cust_id_n,
customer.cust_name_s,
phone.phone_phonenum_s,
phone.phone_type_s
FROM customer JOIN phone
ON customer.cust_id_n = phone.phone_custid_fn;

SELECT c.cust_id_n,
c.cust_name_s,
p.phone_phonenum_s
FROM customer c,
phone p
WHERE c.cust_id_n = p.phone_custid_fn;



CREATE VIEW v_customer_totals
(
	customer_name,
	order_number,
	total_price
)
 AS
(
SELECT 	customer.cust_name_s, 
	   	order_header.ordhdr_nbr_s, 
	   	sum(product.prod_price_n * order_line.ordline_ordqty_n) 
FROM   	customer, 
	   	order_header,
	   	order_line,
	   	product 
WHERE	customer.cust_id_n = order_header.ordhdr_custid_fn
AND		order_header.ordhdr_id_n = order_line.ordline_ordhdrid_fn
AND		product.prod_id_n = order_line.ordline_prodid_fn
AND		order_line.ordline_ordqty_n IS NOT NULL
GROUP BY	customer.cust_name_s,
order_header.ordhdr_nbr_s
)
;


SELECT ct.order_number,
ct.total_price,
ct.total_price * d.disc_pct / 100 AS
total_discount
FROM v_customer_totals ct JOIN discount d
ON ct.total_price >= d.disc_minamount_n
AND ct.total_price < d.disc_maxamount_n;

SELECT order_number,
total_price,
total_price * disc_pct / 100 AS total_discount
FROM v_customer_totals ct,
discount d
WHERE ct.total_price > d.disc_minamount_n
AND ct.total_price < d.disc_maxamount_n;

SELECT r.reseller_id_n AS res_id,
r.reseller_name_s AS res_name,
s.reseller_id_n AS sup_id,
s.reseller_name_s AS sup_name
FROM reseller r JOIN reseller s
ON r.reseller_supplier_id = s.reseller_id_n;

SELECT r.reseller_id_n AS res_id,
r.reseller_name_s AS res_name,
s.reseller_id_n AS sup_id,
s.reseller_name_s AS sup_name
FROM reseller r,
reseller s
WHERE r.reseller_supplier_id = s.reseller_id_n;

SELECT cust_name_s,
phone_phonenum_s
FROM customer CROSS JOIN
phone;

SELECT cust_name_s,
phone_phonenum_s
FROM customer,
phone;

SELECT DISTINCT customer.cust_name_s,
product.prod_description_s FROM customer
JOIN order_header
ON customer.cust_id_n =
order_header.ordhdr_custid_fn
JOIN order_line
ON order_header.ordhdr_id_n = order_line.ordline_ordhdrid_fn
JOIN product
ON product.prod_id_n =
order_line.ordline_prodid_fn;


SELECT cust_name_s,
ordhdr_nbr_s,
status_desc_s
FROM customer
JOIN
order_header
ON cust_id_n = ordhdr_custid_fn
JOIN
status
ON status_id_n = ordhdr_statusid_fn;

SELECT cust_name_s,
ordhdr_nbr_s,
status_desc_s
FROM customer,
order_header,
status
WHERE cust_id_n = ordhdr_custid_fn
AND status_id_n = ordhdr_statusid_fn;

SELECT r.reseller_id_n AS res_id,
r.reseller_name_s AS res_name,
s.reseller_id_n AS sup_id,
s.reseller_name_s AS sup_name
FROM reseller r
LEFT OUTER JOIN
reseller s
ON r.reseller_supplier_id =
s.reseller_id_n;

SELECT cust_name_s,
ordhdr_nbr_s
FROM customer
JOIN
order_header
ON cust_id_n = ordhdr_custid_fn
WHERE cust_id_n = 152;

SELECT cust_name_s,
ordhdr_nbr_s,
payterms_desc_s
FROM customer
JOIN
order_header
ON cust_id_n = ordhdr_custid_fn
JOIN
payment_terms
ON payterms_id_n = ordhdr_payterms_fn
WHERE cust_id_n = 152;

SELECT cust_name_s,
ordhdr_nbr_s,
payterms_desc_s
FROM customer
JOIN
order_header
ON cust_id_n = ordhdr_custid_fn
LEFT OUTER JOIN
payment_terms
ON payterms_id_n = ordhdr_payterms_fn
WHERE cust_id_n = 152;


SELECT cust_name_s,
ordhdr_nbr_s,
payterms_desc_s
FROM payment_terms
RIGHT OUTER JOIN
order_header
ON payterms_id_n = ordhdr_payterms_fn
JOIN
customer
ON cust_id_n = ordhdr_custid_fn
WHERE cust_id_n = 152;


SELECT customer.cust_name_s,
order_header.ordhdr_nbr_s
FROM customer
FULL OUTER JOIN
order_header
ON customer.cust_id_n = order_header.ordhdr_custid_fn;

SELECT s.salesman_name_s,
p.phone_phonenum_s
FROM salesman s
JOIN
(SELECT cust_salesmanid_fn,
ordhdr_custid_fn,
COUNT(ordhdr_nbr_s) cnt
FROM customer
JOIN
order_header
ON cust_id_n = ordhdr_custid_fn
GROUP BY ordhdr_custid_fn,
cust_salesmanid_fn
HAVING COUNT(ordhdr_nbr_s) > 5) c
ON s.salesman_id_n = c.cust_salesmanid_fn
JOIN phone p
ON p.phone_salesmanid_fn = s.salesman_id_n
WHERE p.phone_type_s = 'PHONE';


SELECT ordhdr_custid_fn,
COUNT(ordhdr_nbr_s) cnt
FROM order_header
GROUP BY ordhdr_custid_fn
HAVING COUNT(ordhdr_nbr_s) > 5;

SELECT cust_salesmanid_fn,
ordhdr_custid_fn,
COUNT(ordhdr_nbr_s) cnt
FROM customer
JOIN
order_header
ON cust_id_n = ordhdr_custid_fn
GROUP BY ordhdr_custid_fn,
cust_salesmanid_fn
HAVING COUNT(ordhdr_nbr_s) > 5;

SELECT s.salesman_name_s,
c.ordhdr_custid_fn,
c.cnt
FROM salesman s
JOIN
(SELECT cust_salesmanid_fn,
ordhdr_custid_fn,
COUNT(ordhdr_nbr_s) cnt
FROM customer
JOIN
order_header
ON cust_id_n = ordhdr_custid_fn
GROUP BY ordhdr_custid_fn,
cust_salesmanid_fn
HAVING COUNT(ordhdr_nbr_s) > 5) c
ON s.salesman_id_n = c.cust_salesmanid_fn;

SELECT s.salesman_name_s,
p.phone_phonenum_s
FROM salesman s
JOIN
(SELECT cust_salesmanid_fn,
ordhdr_custid_fn,
COUNT(ordhdr_nbr_s) cnt
FROM customer
JOIN
order_header
ON cust_id_n = ordhdr_custid_fn
GROUP BY ordhdr_custid_fn,
cust_salesmanid_fn
HAVING COUNT(ordhdr_nbr_s) > 5) c
ON s.salesman_id_n = c.cust_salesmanid_fn
JOIN phone p
ON p.phone_salesmanid_fn = s.salesman_id_n
WHERE p.phone_type_s = 'PHONE';

SELECT
DISTINCT c.cust_name_s,
p.phone_phonenum_s
FROM customer c,
phone p
WHERE c.cust_id_n = p.phone_custid_fn
AND EXISTS (SELECT *
FROM order_header oh
WHERE oh.ordhdr_custid_fn =
c.cust_id_n)
AND p.phone_type_s = 'PHONE';

SELECT
DISTINCT c.cust_name_s,
p.phone_phonenum_s
FROM customer c
JOIN
order_header oh
ON c.cust_id_n = oh.ordhdr_custid_fn
JOIN
phone p
ON c.cust_id_n = p.phone_custid_fn
WHERE p.phone_type_s = 'PHONE';
