-- The following statements assume the ACME database is empty,
-- i.e. created by empty_acme.sql script.

CREATE TABLE status 
(
    status_id_n INT,
    status_code_s CHAR(2),
    status_desc_s VARCHAR(30)
) 
GO

INSERT INTO status
       (STATUS_ID_N, STATUS_CODE_S, STATUS_DESC_S)
VALUES (8,'70','INVOICED')
GO

UPDATE status 
SET    status_desc_s = 'APPROVED' 
WHERE  status_id_n = 8
GO

UPDATE status 
SET    status_desc_s = 'APPROVED', 
       status_code_s = '90'
WHERE  status_id_n = 8
GO

DELETE status 
WHERE  status_id_n = 8
GO

-- The following statements assume the ACME database is created,
-- and populated using create_acme_mssql.sql and load_data_mssql.dat scripts
-- as explained in Appendix F.

SELECT customer_name,
       order_number,
       total_price
FROM   v_customer_totals
GO

SELECT customer_name, 
       order_number, 
       (total_price-(total_price * 0.085)) net_sale 
FROM   v_customer_totals
GO

SELECT    customer_name, 
          order_number, 
          (total_price-(total_price * 0.085)) net_sale 
FROM      v_customer_totals
ORDER BY  net_sale
GO

SELECT    customer_name, 
          order_number, 
          (total_price-(total_price * 0.085)) net_sale 
FROM      v_customer_totals
ORDER BY  net_sale DESC
GO

SELECT SUM(total_price) net_sale_total 
FROM   v_customer_totals
GO

SELECT AVG(total_price) net_sale_average
FROM v_customer_totals
GO

