-- The following statements assume incremental ACME database creation
-- started in Chapter 2, Chapter 4, and Chapter 5 after creating 
-- an empty database using empty_acme.sql script.

DELETE FROM PRODUCT
GO

INSERT INTO product
(
prod_id_n,
prod_num_s,
prod_description_s,
prod_status_s,
prod_brand_s,
prod_pltwid_n,
prod_pltlen_n
)
VALUES
(
991,
'991',
'SPRUCE LUMBER 30X40X50',
'N',
'SPRUCE LUMBER',
4,
6
)
GO

DROP TABLE PAYMENT_TERMS3

CREATE TABLE payment_terms3(
payterms_id_n INTEGER NOT NULL,
payterms_code_s VARCHAR(20),
payterms_desc_s VARCHAR(50),
payterms_discpct_n INTEGER,
payterms_daystopay_n INTEGER,
CONSTRAINT PK_PAYTERMS_01 PRIMARY KEY ( payterms_id_n))
GO 

INSERT INTO payment_terms3
(
payterms_id_n,
payterms_code_s,
payterms_desc_s,
payterms_discpct_n,
payterms_daystopay_n
)
VALUES
(27,'N21531','2% 15 NET 30',
0.02,
31
)
GO

INSERT INTO payment_terms3
(
payterms_id_n,
payterms_code_s,
payterms_desc_s,
payterms_discpct_n,
payterms_daystopay_n
)
VALUES
(
28,
'N21530',
'2% 15 NET 30',
0.02,
30
)
GO

DELETE FROM  SALESMAN
GO

INSERT INTO salesman
(
salesman_id_n,
salesman_code_s,
salesman_name_s
)
VALUES
(
22,
'0B',
'FAIRFIELD MOSQUITO ASSOCIATION'
)
GO

SELECT *
FROM salesman
WHERE salesman_code_s = '0B'
GO

ALTER TABLE  CUSTOMER
DROP     CONSTRAINT FK_CUST_PAYTERMS
GO

ALTER TABLE  CUSTOMER
DROP     CONSTRAINT FK_CUST_SALESMAN 
GO

INSERT INTO customer
(
cust_id_n,
cust_paytermsid_fn,
cust_salesmanid_fn,
cust_name_s,
cust_alias_s,
cust_credhold_s
)
VALUES
(
1,
27,
24,
'WILE SEAL CORP.',
'MNGA71396',
'Y'
)
GO

SELECT cust_status_s
FROM customer
WHERE cust_alias_s = 'MNGA71396'
GO 

INSERT INTO product
(
prod_id_n,
prod_price_n,
prod_num_s,
prod_description_s,
prod_status_s,
prod_brand_s,
prod_pltwid_n,
prod_pltlen_n,
prod_netwght_n,
prod_shipweight_n
)
VALUES
(
1880,
33.28,
'1880',
'STEEL NAILS 6''''',
'Y',
'STEEL NAILS',
5,
4,
38.39148,
42.39148
)
GO 

DELETE FROM PRODUCT
GO



INSERT INTO product
(
prod_id_n,
prod_price_n,
prod_num_s,
prod_description_s,
prod_status_s,
prod_brand_s,
prod_pltwid_n,
prod_pltlen_n,
prod_netwght_n,
prod_shipweight_n
)
VALUES
(
5786,
NULL,
'5786',
'CRATING MATERIAL 12X48X72',
'Y',
'CRATING MATERIAL',
5,
6,
20.37674,
23.37674
)
GO


ALTER TABLE  SALESMAN
DROP     CONSTRAINT CHK_SALESSTATUS
GO

INSERT INTO salesman
(
salesman_id_n,
salesman_code_s,
salesman_name_s,
salesman_status_s
)
VALUES
(
26,
'07',
'ELMERSON INDUSTRIES INCORPORATED','A'
)
GO

CREATE TABLE defaults
(
c1 int identity,
c2 varchar(30) DEFAULT ('column default'),
c3 timestamp,
c4 int NULL
)
GO

INSERT INTO defaults
DEFAULT VALUES
GO

SELECT *
FROM defaults
GO

DELETE FROM payment_terms
GO

INSERT INTO payment_terms
(
payterms_id_n,
payterms_code_s,
payterms_desc_s,
payterms_discpct_n,
payterms_daystopay_n
)
VALUES
(
26,
'N30',
'NET 30',
0,
30
)
GO


SET IDENTITY_INSERT payment_terms ON

DELETE FROM payment_terms
GO

INSERT INTO payment_terms
(
payterms_id_n,
payterms_code_s,
payterms_desc_s,
payterms_discpct_n,
payterms_daystopay_n
)
VALUES
(
26,
'N30',
'NET 30',
0,
30
)
GO

 UPDATE product
SET prod_price_n = 34.76
GO

UPDATE product
SET prod_price_n = 34.76
WHERE prod_num_s = '1880'
GO

UPDATE product
SET prod_price_n = 18.24
WHERE prod_id_n = 990
GO

UPDATE product
SET prod_pltwid_n = 5,
prod_pltlen_n = 7
WHERE prod_id_n = 990
GO

UPDATE product
SET prod_price_n = prod_price_n * 1.1
GO

UPDATE order_header
SET ordhdr_payterms_fn =
(SELECT payterms_id_n
FROM payment_terms
WHERE payterms_code_s = 'N21531')
WHERE ordhdr_id_n = 30670
GO

UPDATE order_header
SET ordhdr_payterms_fn =
(SELECT payterms_id_n
FROM payment_terms,
customer
WHERE payterms_id_n = cust_paytermsid_fn
AND ordhdr_custid_fn = cust_id_n)
GO

UPDATE order_header
SET ordhdr_payterms_fn = payterms_id_n
FROM payment_terms JOIN customer
ON payterms_id_n = cust_paytermsid_fn JOIN
order_header
ON ordhdr_custid_fn = cust_id_n
GO

DELETE FROM salesman
WHERE salesman_code_s = '02'
GO



DELETE FROM phone
GO


DELETE order_header
FROM order_header JOIN customer
ON ordhdr_custid_fn = cust_id_n
WHERE cust_name_s = 'WILE SEAL CORP.'
GO

DROP TABLE LOCAL_PRODUCT
GO

CREATE TABLE LOCAL_PRODUCT
(
PROD_ID_N INTEGER NOT NULL,
PROD_PRICE_N INTEGER,
PROD_NUM_S VARCHAR (10),
PROD_DESCRIPTION_S VARCHAR (44) NOT NULL,
PROD_STATUS_S CHAR (1) DEFAULT 'Y',
PROD_BRAND_S VARCHAR (20) NOT NULL,
PROD_PLTWID_N INTEGER NOT NULL,
PROD_PLTLEN_N INTEGER NOT NULL,
PROD_NETWGHT_N INTEGER,
PROD_SHIPWEIGHT_N INTEGER,
CONSTRAINT CHK_LPRODSTATUS
CHECK (PROD_STATUS_S in ('N', 'Y')),
CONSTRAINT PK_LPRODUCTPRIM PRIMARY KEY ( PROD_ID_N )
)
GO

MERGE INTO local_product lp
USING product p ON (lp.prod_id_n = p.prod_id_n )
WHEN MATCHED THEN UPDATE
SET lp.prod_price_n = p.prod_price_n,
lp.prod_status_s = p.prod_status_s,
lp.prod_pltwid_n = p.prod_pltwid_n,
lp.prod_pltlen_n = p.prod_pltlen_n,
lp.prod_shipweight_n = p.prod_shipweight_n
WHEN NOT MATCHED THEN INSERT
VALUES (p.prod_id_n,
p.prod_price_n,
p.prod_num_s,
p.prod_description_s,
p.prod_status_s,
p.prod_brand_s,
p.prod_pltwid_n,
p.prod_pltlen_n,
p.prod_netwght_n,
p.prod_shipweight_n);
GO

MERGE INTO local_product lp
USING product p ON (lp.prod_id_n = p.prod_id_n )
WHEN MATCHED AND (p.prod_status_s = 'Y') THEN UPDATE
SET lp.prod_price_n = p.prod_price_n,
lp.prod_status_s = p.prod_status_s,
lp.prod_pltwid_n = p.prod_pltwid_n,
lp.prod_pltlen_n = p.prod_pltlen_n,
lp.prod_shipweight_n = p.prod_shipweight_n
WHEN MATCHED AND (p.prod_status_s = 'N') THEN DELETE
WHEN NOT MATCHED THEN INSERT
VALUES (p.prod_id_n,
p.prod_price_n,
p.prod_num_s,
p.prod_description_s,
p.prod_status_s,
p.prod_brand_s,
p.prod_pltwid_n,
p.prod_pltlen_n,
p.prod_netwght_n,
p.prod_shipweight_n)
WHEN SOURCE NOT MATCHED THEN DELETE;





