

USE acme
GO


GRANT CREATE VIEW
TO PUBLIC
GO

GRANT SELECT
ON product
TO PUBLIC
GO

GRANT SELECT, 
      UPDATE (prod_id_n,
              prod_price_n)
ON product
TO PUBLIC
GO


REVOKE SELECT
ON product
FROM PUBLIC
GO

DROP VIEW v_customer_status
GO 

CREATE VIEW v_customer_status
(
  name,
  status
)
AS
SELECT cust_name_s,
       cust_status_s
FROM   customer
GO

SELECT *
FROM v_customer_status
GO

DROP VIEW v_customer_totals_over_15000
GO

CREATE VIEW v_customer_totals_over_15000
AS
SELECT *
FROM   v_customer_totals
WHERE  total_price < 15000
GO

SELECT DISTINCT cust_name_s
FROM   customer cu 
  JOIN 
       order_header oh
  ON   cu.cust_id_n = oh.ordhdr_custid_fn
GO

ALTER TABLE ADDRESS
DROP CONSTRAINT chk_addr_type
GO

ALTER TABLE address
ADD CONSTRAINT chk_addr_type
CHECK (addr_type_s = 'SHIPPING' OR addr_type_s = 'BILLING')
GO

ALTER TABLE customer
ADD CONSTRAINT df_customer_cust_s
DEFAULT ('Y')
FOR cust_status_s
GO

ALTER TABLE address
DROP CONSTRAINT  fk_addr_cust
GO

ALTER TABLE address
ADD CONSTRAINT fk_addr_cust
FOREIGN KEY(addr_custid_fn)
REFERENCES customer(cust_id_n)
GO

DROP VIEW v_customer_status
GO 

CREATE VIEW v_customer_status
(
  name,
  status
)
WITH ENCRYPTION
AS
SELECT cust_name_s,
       cust_status_s
FROM   customer
GO