


SELECT PROD_ID_N as ID, PROD_PRICE_N as "Price"
FROM product 
FOR XML RAW
GO


SELECT PROD_ID_N as ID, PROD_PRICE_N as Price
FROM product 
FOR XML AUTO
GO

SELECT 1    as Tag,
       NULL as Parent,
       PROD_ID_N as  [element!1!PROD_ID_N],
       PROD_PRICE_N as [element!1!PROD_PRICE_N]
FROM product FOR XML EXPLICIT 
GO

UPDATE product SET PROD_REPORT_X ='  
<productinfo>
        <name>SPF</name>
         <spec>
                <thickness>2</thickness>
                <width>4</width>
        </spec>
        <grade type="commercial">2BTR</grade>
</productinfo>'
WHERE PROD_ID_N=990
GO 

UPDATE product
SET PROD_REPORT_X.modify(
'insert <bf>1000</bf> as first
  into(/productinfo/spec)[1]')
WHERE PROD_ID_N=990;
GO

UPDATE product
SET PROD_REPORT_X.modify(
'insert attribute type{"internal"}
  		into(/productinfo/spec)[1]')
WHERE PROD_ID_N=990;
GO

UPDATE product
SET PROD_REPORT_X.modify
('
insert( 
<bf>1000</bf>, 
<ln>100</ln>)
  		into(/productinfo/spec)[1]')
WHERE PROD_ID_N=990; 
GO

UPDATE product
SET PROD_REPORT_X.modify
('replace 
value of (/productinfo/name/text())[1]
  		with  "F/L"')
WHERE PROD_ID_N=990;
GO

UPDATE product
SET PROD_REPORT_X.modify
('replace 
value of (/productinfo/grade/@type)[1]
  		with  "custom"')
WHERE PROD_ID_N=990;
GO

UPDATE product
SET PROD_REPORT_X.modify
('delete(/productinfo/grade)[1]')
WHERE PROD_ID_N=990;
GO

UPDATE product
SET PROD_REPORT_X.modify
('delete/productinfo/grade/@type')
WHERE PROD_ID_N=990;
GO

SELECT PROD_REPORT_X.query('/productinfo/spec') 
FROM product
WHERE PROD_ID_N=990;
GO

SELECT 
PROD_REPORT_X.value
('(/productinfo/spec/width)[1]', 'int' )
FROM product 
WHERE PROD_ID_N=990;
GO

SELECT PROD_ID_N
FROM product
WHERE PROD_REPORT_X.exist
('/productinfo[name="SPF"]')=1
GO

CREATE PRIMARY XML INDEX 
report_idx on product (PROD_REPORT_X)
GO

CREATE XML INDEX report_idx_path ON product(PROD_REPORT_X)
USING XML INDEX report_idx FOR PATH
GO

CREATE XML INDEX report_idx_value ON product(PROD_REPORT_X)
USING XML INDEX report_idx
FOR VALUE
GO

CREATE XML INDEX report_idx_property ON product(PROD_REPORT_X)
USING XML INDEX report_idx
FOR PROPERTY
GO

