-- The following UPDATE statements assume the ACME database is created,
-- and populated using load.sql script as explained in Appendix F.

UPDATE shipment
SET shipment_arrivdate_d = '03-SEP-02'
WHERE shipment_id_n = 30661;

UPDATE shipment
SET shipment_arrivdate_d = DATE '2003-09-02'
WHERE shipment_id_n = 30661;

UPDATE shipment
SET shipment_arrivdate_d = TO_DATE('September, 02 2003','Month, DD YYYY')
WHERE shipment_id_n = 30661;

CREATE TYPE addr_type AS OBJECT (
street VARCHAR(30),
city VARCHAR(30),
state CHAR(2),
zip VARCHAR(10),
country VARCHAR(30),
type_of_addr CHAR(1));

CREATE TABLE cust1 (
id NUMBER,
name VARCHAR(30),
address ADDR_TYPE );

CREATE TYPE addr_type_tab
AS TABLE OF addr_type;

CREATE TABLE cust2 (
id NUMBER,
name VARCHAR(30),
address addr_type_tab)
NESTED TABLE address STORE AS addr_storage;

CREATE TYPE addr_type_varray
AS VARRAY(50) OF addr_type;

CREATE TABLE cust3 (
id NUMBER,
name VARCHAR(30),
address ADDR_TYPE_VARRAY);

