-- The following statements assume incremental ACME database creation
-- started in Chapter 2  and Chapter 4 after creating 
-- an empty database using empty_acme.sql script.

ALTER TABLE PHONE
ADD PHONE_PRIMARY_S CHAR(1) DEFAULT 'Y'
CHECK (PHONE_PRIMARY_S IN ('Y', 'N'))
ADD PHONE_CATEGORY_S CHAR(15);

ALTER TABLE PHONE
MODIFY PHONE_PRIMARY_S CHAR(1) NOT NULL
MODIFY PHONE_CATEGORY_S VARCHAR2(20) DEFAULT
'BUSINESS';

ALTER TABLE PHONE
DROP (PHONE_PRIMARY_S, PHONE_CATEGORY_S);

ALTER TABLE SALESMAN
MODIFY CONSTRAINT chk_salesstatus INITIALLY IMMEDIATE;

ALTER TABLE SALESMAN
MODIFY CONSTRAINT chk_salesstatus INITIALLY DEFERRED;

ALTER TABLE salesman
ADD CONSTRAINT uk_salesmancode UNIQUE (salesman_code_s);

ALTER TABLE product
ADD CONSTRAINT pk_productprim PRIMARY KEY (prod_id_n);

ALTER TABLE customer ADD CONSTRAINT fk_cust_payterms
FOREIGN KEY (cust_paytermsid_fn)
REFERENCES payment_terms (payterms_id_n);

ALTER TABLE customer ADD CONSTRAINT fk_cust_salesman
FOREIGN KEY (cust_salesmanid_fn)
REFERENCES salesman (salesman_id_n);

ALTER TABLE order_line ADD CONSTRAINT fk_ordline_ordhdr
FOREIGN KEY (ordline_ordhdrid_fn)
REFERENCES order_header (ordhdr_id_n);

ALTER TABLE order_line ADD CONSTRAINT fk_ordline_product
FOREIGN KEY (ordline_prodid_fn)
REFERENCES product (prod_id_n);

ALTER TABLE SALESMAN
DROP CONSTRAINT uk_salesmancode;

ALTER TABLE SALESMAN
DISABLE CONSTRAINT chk_salesstatus;

ALTER TABLE SALESMAN
ENABLE CONSTRAINT chk_salesstatus;

ALTER TABLE SALESMAN
RENAME TO SALESPERSON;

ALTER TABLE SALESPERSON
RENAME TO SALESMAN;

DROP TABLE CUSTOMER;

ALTER VIEW v_contact_list
ADD CONSTRAINT vpk_contactlist UNIQUE (name,
phone_number) DISABLE;

ALTER VIEW v_contact_list
DROP CONSTRAINT vpk_contactlist;

DROP VIEW v_phone_number;

ALTER SEQUENCE my_sequence4
INCREMENT BY 1
NOMAXVALUE
NOCYCLE;

DROP SEQUENCE my_sequence1;

DROP MATERIALIZED VIEW TEST2 PRESERVE TABLE;

DROP DIRECTORY ACME;





