-- The following statements assume incremental ACME database creation
-- started in Chapter 2, Chapter 4, and Chapter 5 after creating 
-- an empty database using empty_acme.sql script.

INSERT INTO product
(
prod_id_n,
prod_num_s,
prod_description_s,
prod_status_s,
prod_brand_s,
prod_pltwid_n,
prod_pltlen_n
)
VALUES
(
991,
'991',
'SPRUCE LUMBER 30X40X50',
'N',
'SPRUCE LUMBER',
4,
6
);

CREATE TABLE PAYMENT_TERMS3
(
    PAYTERMS_ID_N           NUMBER          NOT NULL,
    PAYTERMS_CODE_S         VARCHAR2(6),
    PAYTERMS_DESC_S         VARCHAR2(60),
    PAYTERMS_DISCPCT_N      NUMBER,
    PAYTERMS_DAYSTOPAY_N    NUMBER,
    CONSTRAINT PK_PAYTERMS3 PRIMARY KEY (PAYTERMS_ID_N)
);


INSERT INTO payment_terms3
(
payterms_id_n,
payterms_code_s,
payterms_desc_s,
payterms_discpct_n,
payterms_daystopay_n
)
VALUES
(
27,
'N21531',
'2% 15 NET 30',
0.02,
31
);

INSERT INTO payment_terms3
(
payterms_id_n,
payterms_code_s,
payterms_desc_s,
payterms_discpct_n,
payterms_daystopay_n
)
VALUES
(
28,
'N21530',
'2% 15 NET 30',
0.02,
30
);

INSERT INTO salesman
(
salesman_id_n,
salesman_code_s,
salesman_name_s
)
VALUES
(
22,
'0B',
'FAIRFIELD MOSQUITO ASSOCIATION'
);

SELECT *
FROM salesman
WHERE salesman_code_s = '0B';

-- If CUSTOMER table has previously been dropped, recreate it:
CREATE TABLE customer
(
    cust_id_n             NUMBER          NOT NULL,
    cust_paytermsid_fn    NUMBER,
    cust_salesmanid_fn    NUMBER,
    cust_status_s         VARCHAR2(1)     DEFAULT 'Y' NOT NULL,
    cust_name_s           VARCHAR2(50)    NOT NULL,
    cust_alias_s          VARCHAR2(15),
    cust_credhold_s       VARCHAR2(1)     DEFAULT 'Y' NOT NULL,
    CONSTRAINT chk_cust_status CHECK (cust_status_s IN ('N', 'Y')),
    CONSTRAINT chk_cust_credhold CHECK (cust_credhold_s IN ('N', 'Y')),
    CONSTRAINT pk_custprimary PRIMARY KEY (cust_id_n)
);

INSERT INTO customer
(
cust_id_n,
cust_paytermsid_fn,
cust_salesmanid_fn,
cust_name_s,
cust_alias_s,
cust_credhold_s
)
VALUES
(
1,
27,
24,
'WILE SEAL CORP.',
'MNGA71396',
'Y'
);

SELECT cust_status_s
FROM customer
WHERE cust_alias_s = 'MNGA71396';

INSERT INTO product
(
prod_id_n,
prod_price_n,
prod_num_s,
prod_description_s,
prod_status_s,
prod_brand_s,
prod_pltwid_n,
prod_pltlen_n,
prod_netwght_n,
prod_shipweight_n
)
VALUES
(
1880,
33.28,
'1880',
'STEEL NAILS 6''''',
'Y',
'STEEL NAILS',
5,
4,
38.39148,
42.39148
)

INSERT INTO product
(
prod_id_n,
prod_price_n,
prod_num_s,
prod_description_s,
prod_status_s,
prod_brand_s,
prod_pltwid_n,
prod_pltlen_n,
prod_netwght_n,
prod_shipweight_n
)
VALUES
(
5786,
NULL,
'5786',
'CRATING MATERIAL 12X48X72',
'Y',
'CRATING MATERIAL',
5,
6,
20.37674,
23.37674
);

INSERT INTO order_header
VALUES
(
30670,
28,
NULL,
1,
24,
'523783',
NULL,
NULL,
NULL,
NULL,
'N',
'Y',
NULL,
'RR',
NULL
);

INSERT INTO salesman
VALUES
(
24,
'03',
'AMERICA GONZALES LIMITED',
DEFAULT
);

CREATE TABLE shipment_archive AS SELECT * FROM shipment
 WHERE ROWNUM <1;

INSERT INTO shipment_archive
SELECT *
FROM shipment
WHERE TRUNC(shipment_createdate_d) < TRUNC(SYSDATE)-180;


INSERT INTO salesman
(
salesman_id_n,
salesman_code_s,
salesman_name_s,
salesman_status_s
)
VALUES
(
26,
'07',
'ELMERSON INDUSTRIES INCORPORATED',
'A'
);


CREATE SEQUENCE seq_addr;

INSERT INTO address
(
addr_id_n,
addr_custid_fn,
addr_salesmanid_fn,
addr_address_s,
addr_type_s,
addr_city_s,
addr_state_s,
addr_zip_s,
addr_country_s
)
VALUES
(
SEQ_ADDR.NEXTVAL,
NULL,
23,
'223 E FLAGLER ST.',
NULL,
'MIAMI',
'FL',
'33131',
'USA'
);

CREATE TABLE status
(
status_id_n NUMBER NOT NULL,
status_code_s CHAR(2),
status_desc_s VARCHAR2(30),
CONSTRAINT pk_statusprim PRIMARY KEY (status_id_n)
);

INSERT ALL
INTO status (status_id_n, status_code_s, status_desc_s)
VALUES ( 2, '20', 'COMPLETE')
INTO status (status_id_n, status_code_s, status_desc_s)
VALUES ( 6, '60', 'SHIPPED')
INTO status (status_id_n, status_code_s, status_desc_s)
VALUES ( 8, '70', 'INVOICED')
INTO status (status_id_n, status_code_s, status_desc_s)
VALUES ( 9, '80', 'CANCELLED')
SELECT * FROM dual;

SELECT prod_id_n, prod_description_s, prod_shipweight_n
FROM product;


CREATE TABLE small_product AS
SELECT * FROM product
WHERE prod_id_n < 0;

CREATE TABLE large_product AS
SELECT * FROM product
WHERE prod_id_n < 0;

CREATE TABLE undetermined_product AS
SELECT * FROM product
WHERE prod_id_n < 0;


INSERT ALL
WHEN prod_shipweight_n <= 30 THEN
INTO small_product
WHEN prod_shipweight_n > 30 THEN
INTO large_product
ELSE
INTO undetermined_product
SELECT * FROM product;

SELECT prod_id_n, prod_description_s, prod_shipweight_n
FROM small_product;


SELECT prod_id_n, prod_description_s, prod_shipweight_n
FROM large_product;

SELECT prod_id_n, prod_description_s, prod_shipweight_n
FROM undetermined_product;

UPDATE product
SET prod_price_n = 34.76;

UPDATE product
SET prod_price_n = 34.76
WHERE prod_num_s = '1880';

UPDATE product
SET prod_price_n = 18.24
WHERE prod_id_n = 990;

UPDATE product
SET prod_pltwid_n = 5,
prod_pltlen_n = 7
WHERE prod_id_n = 990;

UPDATE product
SET prod_price_n = prod_price_n * 1.1;

UPDATE order_header
SET ordhdr_payterms_fn =
(SELECT payterms_id_n
FROM payment_terms
WHERE payterms_code_s = 'N21531')
WHERE ordhdr_id_n = 30670;

UPDATE order_header
SET ordhdr_payterms_fn =
(SELECT payterms_id_n
FROM payment_terms,
customer
WHERE payterms_id_n = cust_paytermsid_fn
AND ordhdr_custid_fn = cust_id_n);

UPDATE small_product
SET (prod_pltwid_n, prod_pltlen_n) = (SELECT
prod_pltwid_n, prod_pltlen_n
FROM product
WHERE prod_id_n =
5786)
WHERE prod_id_n = 5786;

DELETE FROM salesman
WHERE salesman_code_s = '02';


DELETE FROM phone;

DELETE FROM order_header
WHERE ordhdr_custid_fn =
(SELECT cust_id_n
FROM customer
WHERE cust_name_s = 'WILE SEAL
CORP.');

CREATE TABLE LOCAL_PRODUCT
(
PROD_ID_N NUMBER NOT NULL,
PROD_PRICE_N NUMBER,
PROD_NUM_S VARCHAR (10),
PROD_DESCRIPTION_S VARCHAR (44) NOT NULL,
PROD_STATUS_S CHAR (1) DEFAULT 'Y',
PROD_BRAND_S VARCHAR (20) NOT NULL,
PROD_PLTWID_N NUMBER NOT NULL,
PROD_PLTLEN_N NUMBER NOT NULL,
PROD_NETWGHT_N NUMBER,
PROD_SHIPWEIGHT_N NUMBER,
CONSTRAINT CHK_LPRODSTATUS
CHECK (PROD_STATUS_S in ('N', 'Y')),
CONSTRAINT PK_LPRODUCTPRIM PRIMARY KEY ( PROD_ID_N )
);

MERGE INTO local_product lp
USING product p ON (lp.prod_id_n = p.prod_id_n )
WHEN MATCHED THEN UPDATE
SET lp.prod_price_n = p.prod_price_n,
lp.prod_status_s = p.prod_status_s,
lp.prod_pltwid_n = p.prod_pltwid_n,
lp.prod_pltlen_n = p.prod_pltlen_n,
lp.prod_shipweight_n = p.prod_shipweight_n
WHEN NOT MATCHED THEN INSERT
VALUES (p.prod_id_n,
p.prod_price_n,
p.prod_num_s,
p.prod_description_s,
p.prod_status_s,
p.prod_brand_s,
p.prod_pltwid_n,
p.prod_pltlen_n,
p.prod_netwght_n,
p.prod_shipweight_n);

MERGE INTO local_product lp
USING product p ON (lp.prod_id_n = p.prod_id_n )
WHEN MATCHED THEN UPDATE
SET lp.prod_price_n = p.prod_price_n,
lp.prod_status_s = p.prod_status_s,
lp.prod_pltwid_n = p.prod_pltwid_n,
lp.prod_pltlen_n = p.prod_pltlen_n,
lp.prod_shipweight_n = p.prod_shipweight_n
DELETE WHERE (p.prod_status_s = 'N')
WHEN NOT MATCHED THEN INSERT
VALUES (p.prod_id_n,
p.prod_price_n,
p.prod_num_s,
p.prod_description_s,
p.prod_status_s,
p.prod_brand_s,
p.prod_pltwid_n,
p.prod_pltlen_n,
p.prod_netwght_n,
p.prod_shipweight_n);

ALTER TABLE ORDER_LINE DISABLE CONSTRAINT
FK_ORDLINE_PRODUCT;

TRUNCATE TABLE PRODUCT;

ALTER TABLE ORDER_LINE ENABLE CONSTRAINT
FK_ORDLINE_PRODUCT;








