-- Starting with Chapter 8, all statements assume the ACME database is created,
-- and populated using load.sql script as explained in Appendix F.

SELECT cust_name_s
FROM customer
CUST_NAME_S;

SELECT cust_id_n,
cust_status_s,
cust_name_s
FROM customer;

SELECT *
FROM status;

SELECT status.*, status_desc_s
FROM status;

SELECT DISTINCT payterms_discpct_n
FROM payment_terms;

SELECT DISTINCT payterms_discpct_n,
payterms_code_s
FROM payment_terms;


SELECT SYSDATE FROM dual;

SELECT DISTINCT payterms_discpct_n AS discount_percent
FROM payment_terms;

SELECT cust_name_s,
100 AS NUMERIC_CONSTANT,
'ABC' AS STRING_CONSTANT
FROM customer;

SELECT CAST(prod_id_n AS CHAR(5)) || ' ' || prod_brand_s
AS ID_AND_BRAND
FROM product;

SELECT salesman_code_s,salesman_name_s, sysdate,
user
FROM salesman;

SELECT prod_num_s,
prod_price_n,
(SELECT stax_amt_n
FROM sales_tax
WHERE stax_state_s = 'WA') AS TAX_RATE,
prod_price_n *
(SELECT stax_amt_n
FROM sales_tax
WHERE stax_state_s = 'WA')/100 AS SALES_TAX
FROM product;

SELECT status_id_n,
s.status_code_s,
s.status_desc_s
FROM status s;

SELECT cust.id,
cust.cust_name_s,
cust.active
FROM
(SELECT cust_id_n AS id,
cust_status_s AS active,
cust_name_s,
cust_alias_s AS alias,
cust_credhold_s AS hold
FROM customer) cust;

SELECT cust_id_n,
cust_name_s,
cust_status_s
FROM customer
WHERE cust_id_n = 7;

SELECT cust_id_n,
cust_name_s,
cust_status_s
FROM customer
WHERE cust_id_n = 7;

SELECT prod_description_s,
prod_price_n
FROM product
WHERE prod_price_n > 20 ;

SELECT phone_salesmanid_fn,
phone_phonenum_s,
phone_type_s
FROM phone
WHERE phone_salesmanid_fn IS NOT NULL
AND phone_type_s = 'PHONE';

SELECT phone_salesmanid_fn,
phone_phonenum_s,
phone_type_s
FROM phone
WHERE phone_salesmanid_fn IS NOT NULL
AND phone_type_s = 'PHONE';

SELECT phone_salesmanid_fn,
phone_phonenum_s,
phone_type_s
FROM phone
WHERE phone_salesmanid_fn IS NOT NULL
AND phone_type_s = 'PHONE';

SELECT phone_salesmanid_fn,
phone_phonenum_s,
phone_type_s
FROM phone
WHERE phone_salesmanid_fn IS NOT NULL
AND phone_type_s = 'PHONE';

SELECT phone_salesmanid_fn,
phone_phonenum_s,
phone_type_s
FROM phone
WHERE phone_salesmanid_fn IS NOT NULL
AND phone_type_s = 'PHONE';

SELECT phone_salesmanid_fn,
phone_phonenum_s,
phone_type_s
FROM phone
WHERE phone_salesmanid_fn IS NOT NULL
AND phone_type_s = 'PHONE';

SELECT phone_salesmanid_fn,
phone_phonenum_s,
phone_type_s
FROM phone
WHERE phone_custid_fn IS NULL;

SELECT phone_custid_fn,
phone_phonenum_s,
phone_type_s
FROM phone
WHERE phone_custid_fn IS NOT NULL;

SELECT ordhdr_nbr_s,
ordhdr_orderdate_d
FROM order_header
WHERE ordhdr_custid_fn =
(SELECT cust_id_n
FROM customer
WHERE cust_name_s = 'WILE ELECTRONICS INC.');

SELECT phone_phonenum_s,
phone_type_s
FROM phone
WHERE phone_salesmanid_fn IN
(SELECT salesman_id_n
FROM salesman
WHERE salesman_code_s BETWEEN '07' and '10');

SELECT v_total.customer_name,
v_total.total_price
FROM v_customer_totals v_total
WHERE v_total.total_price >
ANY (SELECT total_price
FROM v_customer_totals_wilebess)
ORDER BY total_price ASC;

SELECT v_total.customer_name,
v_total.total_price
FROM v_customer_totals v_total
WHERE v_total.total_price >
(SELECT MIN(total_price)
FROM v_customer_totals_wilebess)
ORDER BY total_price ASC;

SELECT v_total.customer_name,
v_total.total_price
FROM v_customer_totals v_total
WHERE v_total.total_price >
ALL (SELECT total_price
FROM v_customer_totals_wilebess)
ORDER BY total_price DESC;

SELECT customer_name,
total_price
FROM v_customer_totals
WHERE total_price > (SELECT MAX(total_price)
FROM v_customer_totals_wilebess)
ORDER BY total_price DESC;

SELECT cust_name_s,
cust_alias_s
FROM customer
WHERE cust_id_n IN
(SELECT ordhdr_custid_fn
FROM order_header
WHERE ordhdr_id_n in
(SELECT ordline_ordhdrid_fn
FROM order_line
WHERE ordline_prodid_fn =
(SELECT prod_id_n
FROM product
WHERE prod_description_s = 'CRATING MATERIAL
12X48X72') ) );

SELECT ordline_ordhdrid_fn,
ordline_ordqty_n AS QTY_PER_ITEM
FROM order_line
GROUP BY ordline_ordhdrid_fn,
ordline_ordqty_n;

SELECT
SUM(ordline_ordqty_n) AS TOT_QTY
FROM order_line;

SELECT ordline_ordhdrid_fn,
SUM(ordline_ordqty_n) AS TOT_QTY_PER_ORDER
FROM order_line
GROUP BY ordline_ordhdrid_fn;

SELECT ordline_ordhdrid_fn,
AVG(ordline_ordqty_n) AS AVG_QTY_PER_ORDER
FROM order_line
GROUP BY ordline_ordhdrid_fn;

SELECT ordline_ordhdrid_fn,
SUM(ordline_ordqty_n) TOT_QTY_PER_ORDER
FROM order_line
GROUP BY ordline_ordhdrid_fn
HAVING SUM(ordline_ordqty_n) > 750;

SELECT cust_name_s,
cust_alias_s,
cust_status_s
FROM customer
ORDER BY cust_name_s;

SELECT cust_name_s,
cust_alias_s
FROM customer
ORDER BY cust_status_s;

SELECT prod_id_n,
prod_price_n,
prod_netwght_n
FROM product
ORDER BY prod_price_n ASC,
prod_netwght_n DESC;

SELECT addr_address_s,
addr_type_s
FROM address
ORDER BY addr_type_s
NULLS FIRST;

SELECT prod_id_n,
prod_price_n,
prod_netwght_n
FROM product
ORDER BY 2 ASC,
3 DESC;

SELECT ordline_ordhdrid_fn,
AVG(ordline_ordqty_n) AS AVG_QTY_PER_ORDER
FROM order_line
GROUP BY ordline_ordhdrid_fn
ORDER BY AVG_QTY_PER_ORDER DESC;

SELECT phone_custid_fn OWNER_ID,
'CUSTOMER PHONE' PHONE_TYPE,
phone_phonenum_s
FROM phone
WHERE phone_type_s = 'PHONE'
AND phone_salesmanid_fn IS NULL;

SELECT phone_salesmanid_fn,
'SALESMAN PHONE',
phone_phonenum_s
FROM phone
WHERE phone_type_s = 'PHONE'
AND phone_custid_fn IS NULL;

SELECT phone_custid_fn OWNER_ID,
'CUSTOMER PHONE' PHONE_TYPE,
phone_phonenum_s
FROM phone
WHERE phone_type_s = 'PHONE'
AND phone_salesmanid_fn IS NULL
UNION
SELECT phone_salesmanid_fn,
'SALESMAN PHONE',
phone_phonenum_s
FROM phone
WHERE phone_type_s = 'PHONE'
AND phone_custid_fn IS NULL
ORDER BY 2, 1;

SELECT status_code_s,
status_desc_s
FROM status;

SELECT status_code_s,
status_desc_s
FROM status
UNION
SELECT status_code_s,
status_desc_s
FROM status;

SELECT status_code_s,
status_desc_s
FROM status
UNION ALL
SELECT status_code_s,
status_desc_s
FROM status;

SELECT cust_id_n
FROM customer
INTERSECT
SELECT ordhdr_custid_fn
FROM order_header;

SELECT cust_id_n
FROM customer
WHERE cust_id_n IN
(SELECT ordhdr_custid_fn
FROM order_header);

SELECT cust_id_n
FROM customer
WHERE EXISTS
(SELECT ordhdr_custid_fn
FROM order_header
WHERE ordhdr_custid_fn = cust_id_n);

SELECT cust_id_n
FROM customer;

SELECT ordhdr_custid_fn
FROM order_header;


SELECT cust_name_s,
cust_alias_s,
cust_status_s
FROM customer cust
WHERE NOT EXISTS (SELECT *
FROM order_header
WHERE ordhdr_custid_fn =
cust.cust_id_n);

SELECT ROW_NUMBER() OVER (ORDER BY prod_price_n DESC) AS
rownumber,
prod_id_n,
prod_description_s,
prod_price_n
FROM product;

SELECT RANK() OVER (ORDER BY prod_price_n DESC) AS
rownumber,
prod_id_n,
prod_description_s,
prod_price_n
FROM product;

SELECT DENSE_RANK() OVER (ORDER BY prod_price_n DESC) AS
rownumber,
prod_id_n,
prod_description_s,
prod_price_n
FROM product;


SELECT *
FROM (SELECT ROW_NUMBER() OVER (ORDER BY prod_price_n
DESC) AS rownumber,
prod_id_n,
prod_description_s,
prod_price_n
FROM product
)
WHERE rownumber <= 4;

SELECT *
FROM (SELECT DENSE_RANK() OVER (ORDER BY prod_price_n
DESC) AS rownumber,
prod_id_n,
prod_description_s,
prod_price_n
FROM product
)
WHERE rownumber <= 4;

SELECT *
FROM (SELECT DENSE_RANK() OVER (ORDER BY prod_price_n
ASC) AS rownumber,
prod_id_n,
prod_description_s,
prod_price_n
FROM product
)
WHERE rownumber <= 4;

SELECT *
FROM (SELECT ROW_NUMBER() OVER (ORDER BY prod_price_n
ASC) AS rownumber,
prod_id_n,
prod_description_s,
prod_price_n
FROM product p
)
WHERE rownumber BETWEEN 4 AND 6;

SELECT *
FROM (SELECT prod_id_n,
prod_description_s,
prod_price_n
FROM product
ORDER BY prod_price_n DESC
)
WHERE ROWNUM <= 4;









