
SELECT 
    CEIL (prod_price_n) ceil_price,
    prod_price_n
FROM product;

SELECT 
    FLOOR (prod_price_n) floor_price,
    prod_price_n
FROM product;

SELECT 
    ROUND(prod_price_n,1) round_price,
    prod_price_n
FROM product;


SELECT 
    TRUNC(prod_price_n, 1) trunc_price,
    prod_price_n
FROM product;

SELECT
    SYSDATE,
    TRUNC(SYSDATE) truncated
FROM dual;

SELECT 
    SIGN (prod_price_n) sign_price,
    prod_price_n
FROM product;

SELECT  
    CONCAT( '$', TO_CHAR(prod_price_n)) display_price
FROM product;

SELECT 
    SUBSTR(prod_description_s,1,3)
FROM product;

SELECT
INSTR(PROD_DESCRIPTION_S, CHR(32),1,1) char_position
FROM product;

SELECT
    SUBSTR(prod_description_s,1,
      INSTR(prod_description_s, CHR(32), 1, 1) -1) || '#' ||
      prod_num_s || '#' || '$' ||
      TO_CHAR(prod_price_n)display
FROM  product;

SELECT  
    LENGTH(prod_description_s) length_of_string
FROM product;

SELECT 
    LENGTHB(SYSDATE)
FROM dual;

SELECT  
    UPPER(prod_description_s) upper_case,
    LOWER(prod_description_s) lower_case
FROM product;

SELECT
    REPLACE('aabbaabbaa','aa','bb12')
FROM dual;

SELECT
RPAD('repeat',LENGTH('repeat')*3,'repeat') example
FROM dual;

SELECT
    TRANSLATE('2KRW229',
    '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ',
    '0000000000**********X***************') translate_example
FROM DUAL;

SELECT
    TRANSLATE('4526 43567 6091 1506',
   '0123456789',
   '**********') visa_card_number
FROM dual;

SELECT
    LENGTH(TRIM(LEADING FROM '   three_blanks'))  ltrimmed,
    LENGTH('   three_blanks')  with_leading_blanks
FROM dual;

SELECT
    TRIM(BOTH 'M' FROM 'MM or IBM')  trimmed
FROM dual;

SELECT
    NEW_TIME(TO_DATE('07-30-2007 8:52:15 PM',
    'MM-DD-YY HH:MI:SS PM'),
    'PST', 'EST') eastern_time
FROM dual;

ALTER SESSION SET NLS_DATE_FORMAT='DD-MON-YYYY HH24:MI:SS';

SELECT
    SYSDATE server_date,
    CURRENT_DATE session_date
FROM dual;

ALTER SESSION SET TIME_ZONE ='WET';

SELECT
    SYSDATE server_date,
    CURRENT_DATE session_date
FROM dual;


SELECT
    ADD_MONTHS(TO_DATE('2008-09-05','YYYY-MM-DD'),5) months
FROM dual;

SELECT
    SYSDATE + 20
FROM DUAL;

SELECT
    EXTRACT(YEAR FROM SYSDATE) year_part
FROM DUAL;

SELECT
TO_CHAR(SYSDATE,'DAY') day_name_upper,
TO_CHAR(SYSDATE,'Day') day_name_mixed
FROM DUAL;

SELECT
    TO_CHAR(SYSDATE,'MONTH') day_name_upper,
    TO_CHAR(SYSDATE,'month') day_name_lower
FROM dual;

SELECT
    MONTHS_BETWEEN
   (TO_DATE('08-05-2007','MM-DD-YYYY'),
   TO_DATE('10-05-2007','MM-DD-YYYY')) months_in_between,
    MONTHS_BETWEEN
   (TO_DATE('08-05-2007','MM-DD-YYYY'),
    TO_DATE('10-06-2007','MM-DD-YYYY')) months_fraction
FROM dual;

SELECT
    TO_CHAR(SYSDATE,'DD-DAY-MONTH-YEAR') LONG_DATE
FROM dual;

select
    TO_DATE('09/12/49','DD/MM/RR') a_date
FROM dual;

ALTER SESSION SET NLS_DATE_FORMAT = 'DD-MON-YYYY';

SELECT
    TO_DATE('09/12/49','DD/MM/RR') a_date
FROM dual;

SELECT
    TO_DATE('09/12/51','DD/MM/RR') a_date
FROM dual;

SELECT TO_DATE(
    'Elokuu 10, 2007, 11:00',
    'Month dd, YYYY, HH:MI',
     'NLS_DATE_LANGUAGE = FINNISH') as a_date
FROM DUAL;

SELECT
    TO_CHAR(-1234,'9999MI') result
FROM dual;

SELECT 
     CONVERT(' A ', 'US7ASCII', 'WE8ISO8859P1') translation
FROM dual;

SELECT
    TRANSLATE(' A ' USING CHAR_CS) translation
FROM dual;

SELECT
    UNISTR('\00F5'|| '\00D1') UN
FROM dual;

SELECT
    LENGTHB(unistr('\00F5')) in_bytes,
    LENGTH(unistr('\00F5'))  in_chars,
    LENGTHB('A')             in_bytes,
    LENGTH(unistr('A'))      in_chars
FROM dual;

SELECT  COMPOSE ('o' || UNISTR('\0302'))  AS circumflex
	   ,COMPOSE ('o' || UNISTR('\0303'))  AS tilde
     ,DECOMPOSE (COMPOSE('o' || UNISTR('\0302'))) AS decomposed
FROM DUAL;

SELECT
    CAST (SYSDATE AS VARCHAR2(100)) char_date
FROM dual;

SELECT
    TO_CHAR(SYSDATE)
FROM dual;


SELECT
  USERENV('LANGUAGE') AS charset,
  USER, 
  UID
FROM customer;

SELECT
    cust_name_s,
    cust_credhold_s
FROM customer;

SELECT
cust_name_s,
  DECODE(cust_credhold_s, 'Y', 'good credit',
'N', 'on hold', 'undefined')
FROM customer;

SELECT
    cust_name_s,
    CASE cust_credhold_s
        WHEN 'Y' THEN 'good credit'
        WHEN 'N' THEN 'on hold'
        ELSE 'undefined'
    END
FROM customer;

SELECT
    NULLIF(cust_credhold_s, cust_status_s) compare_stat
FROM customer;

SELECT
    cust_name_s,
    NVL(cust_alias_s, 'undefined')
FROM customer;

SELECT
    cust_name_s,
    NVL2(cust_alias_s, 'alias assigned', 'not assigned' )       alias_status
FROM customer;

SELECT
 4||'5' concat_value,
 '4'+ 5 sum_value
FROM dual;
