CREATE USER   new_user
IDENTIFIED BY it_is_me;

GRANT CREATE TABLE
TO new_user;

GRANT CREATE SESSION
TO new_user
IDENTIFIED BY it_is_me
WITH ADMIN OPTION;

CREATE ROLE sales_force;

GRANT SELECT, UPDATE, DELETE
     ON product
     TO sales_force;

REVOKE CREATE TABLE
     FROM new_user;

-- The following statement would fail if you try to execute it; 
-- you can not revoke privileges on a column-by-column basis in Oracle.
-- REVOKE      INSERT, 
--             DELETE, 
--             UPDATE (cust_paytermsid_fn, cust_salesmanid_fn)
-- ON          CUSTOMER
-- FROM        PUBLIC;

CREATE OR REPLACE VIEW v_customer_status
(
  name,
  status
)
AS
SELECT cust_name_s,
       cust_status_s
FROM   customer;

SELECT *
FROM v_customer_status;

CREATE OR REPLACE VIEW v_customer_totals_over_15000
AS
SELECT *
FROM   v_customer_totals
WHERE  total_price < 15000;

SELECT DISTINCT cust_name_s
FROM   customer cu 
  JOIN 
       order_header oh
  ON   cu.cust_id_n = oh.ordhdr_custid_fn;

AUDIT SELECT TABLE,
      INSERT TABLE,
      DELETE TABLE,
      EXECUTE PROCEDURE
BY ACCESS
WHENEVER NOT SUCCESSFUL;
