UPDATE product 
SET PROD_REPORT_X = XMLType
(' <productinfo>
        <name>SPF</name>
         <spec>
                <thickness>2</thickness>
                <width>4</width>
        </spec>
        <grade type="commercial">2BTR</grade>
</productinfo>')
WHERE PROD_ID_N=990;

SELECT p.PROD_REPORT_X.getCLOBVal()
FROM product p;

SELECT PROD_REPORT_X
FROM product
WHERE XMLExists('/productinfo[name="F/L"]'
PASSING PROD_REPORT_X);

SELECT extract(PROD_REPORT_X, '/productinfo/grade')
"grade"
FROM product
WHERE existsNode(PROD_REPORT_X,
'/productinfo[name="F/L"]') = 1;

SELECT XMLCast(
XMLQuery('/productinfo/name' PASSING PROD_REPORT_X
RETURNING CONTENT)
AS VARCHAR2(1000)) "product_name"
FROM product
WHERE XMLExists('/productinfo[name="SPF"]'
PASSING PROD_REPORT_X);

SELECT updateXML(PROD_REPORT_X,
'/productinfo/grade', '<grade>NSP</grade>') AS XML
FROM product p;

UPDATE product
SET PROD_REPORT_X =
insertChildXML(PROD_REPORT_X,
'/productinfo/spec',
'length',
XMLType('<length>
<bf>1000</bf>
<ln>1000/12*144</ln>
</length>'))
WHERE PROD_ID_N=990;

UPDATE product
SET PROD_REPORT_X =
insertXMLbefore(
PROD_REPORT_X,
'/productinfo/spec',
XMLType('<grade type="commercial">
<description>3 or better</description>
<abbreviation>3BTR</abbreviation>
</grade>')
)
WHERE PROD_ID_N=990;

UPDATE product
SET PROD_REPORT_X =
appendChildXML(PROD_REPORT_X,
'/productinfo',
XMLType('<grade
type="commercial">3BTR</grade>'))
WHERE PROD_ID_N=990;

UPDATE product
SET PROD_REPORT_X =
deleteXML(PROD_REPORT_X, '/productinfo/grade')
WHERE PROD_ID_N=990;

CREATE UNIQUE INDEX xml_fun_idx ON product
(extractValue(PROD_REPORT_X, '/productinfo/name'));

CREATE INDEX xmlindex_idx ON product
(extract(PROD_REPORT_X, '/productinfo/name'))
INDEXTYPE IS XDB.XMLIndex;



